C     Program to translate the output data files from Tpros to produce the
C     actual values for the temperatures Ac1 and Ac3 from the normalised
C     output data.
C     
C     Program written April 1999 by C.A. Walsh.
C
      IMPLICIT NONE
      DOUBLE PRECISION E,US,UT,UTM,UTP,AS,AT,ATM,ATP
      DOUBLE PRECISION AC1MIN,AC1MAX,AC3MIN,AC3MAX,VMIN,VMAX
      INTEGER ITYPE,IIU,IOU,ILINE,L1
      CHARACTER*55 FILE1,FILE2
C
      AC1MIN =  530D0
      AC1MAX =  921D0
      AC3MIN =  651D0
      AC3MAX = 1060D0
      FILE1='                                                       '
      FILE2='                                                       '
      ITYPE = 0
      IIU   = 1
      IOU   = 2
      ILINE = 1
C
  100 WRITE (*,*) 'Translate Ac1 (1) or Ac3 (2)? : '
      READ(*,*) ITYPE
      IF (ITYPE.NE.1.AND.ITYPE.NE.2) GOTO 100
      VMIN = AC1MIN
      VMAX = AC1MAX
      IF (ITYPE.EQ.2) THEN
         VMIN = AC3MIN
         VMAX = AC3MAX
      ENDIF
  110 WRITE (*,*) 'Input number of lines of data :'
      READ (*,*) ILINE
      IF (ILINE.LT.1) THEN
         WRITE (*,*) '*** ERROR*** number of data lines = ',ILINE
         STOP
      ENDIF
C
      WRITE (*,*) 'Input file name of input file :'
      READ (*,*) FILE1
      OPEN (UNIT=IIU,FILE=FILE1,STATUS='OLD') 
      WRITE (*,*) 'Input file name of output file :'
      READ (*,*) FILE2
      OPEN (UNIT=IOU,FILE=FILE2,STATUS='NEW')
      IF (ITYPE.EQ.1) WRITE(IOU,1)
      IF (ITYPE.EQ.2) WRITE(IOU,2)
C
      DO 120 L1=1,ILINE
         READ(IIU,*) UT,US,UTM,UTP,E
         AT  = (UT +0.5D0)*(VMAX-VMIN) + VMIN
         ATM = (UTM+0.5D0)*(VMAX-VMIN) + VMIN         
         ATP = (UTP+0.5D0)*(VMAX-VMIN) + VMIN
         AS  = US*(VMAX-VMIN)
         WRITE(IOU,3) AT,AS,ATM,ATP
  120 CONTINUE
C
      CLOSE(IIU)
      CLOSE(IOU)
      STOP
    1 FORMAT(1H ,
     +    ' Ac1 (deg.C)     error     Range of values for Ac1 (deg. C)')
    2 FORMAT(1H ,
     +    ' Ac3 (deg.C)     error     Range of values for Ac3 (deg. C)')
    3 FORMAT(1H ,1X,F7.2,7X,F7.2,10X,F7.2,'  -  ',F7.2)
      END
